--- configure.in.orig	2014-08-18 14:10:36.737016150 -0400
+++ configure.in	2014-08-19 16:56:12.631193389 -0400
@@ -1763,6 +1763,12 @@ operating system;  use --disable-thread-
 fi
 fi
 
+#  test whether this system has both the librt-style async io and the gcc atomic compare_and_swap
+#      and test operation  of the latter.
+PGAC_FUNC_AIO_ATOMIC_BUILTIN_COMP_SWAP
+if test x"$pgac_cv_aio_atomic_builtin_comp_swap" = x"yes"; then
+      AC_DEFINE(USE_AIO_ATOMIC_BUILTIN_COMP_SWAP, 1, [Define to select librt-style async io and the gcc atomic compare_and_swap.])
+fi
 
 # Select semaphore implementation type.
 if test "$PORTNAME" != "win32"; then
--- contrib/pg_prewarm/pg_prewarm.c.orig	2014-08-18 14:10:36.757016243 -0400
+++ contrib/pg_prewarm/pg_prewarm.c	2014-08-19 16:56:12.947194521 -0400
@@ -159,7 +159,7 @@ pg_prewarm(PG_FUNCTION_ARGS)
 		 */
 		for (block = first_block; block <= last_block; ++block)
 		{
-			PrefetchBuffer(rel, forkNumber, block);
+			PrefetchBuffer(rel, forkNumber, block, 0);
 			++blocks_done;
 		}
 #else
--- contrib/pg_stat_statements/pg_stat_statements--1.3.sql.orig	2014-08-19 10:17:32.814616339 -0400
+++ contrib/pg_stat_statements/pg_stat_statements--1.3.sql	2014-08-19 16:56:12.995194693 -0400
@@ -0,0 +1,52 @@
+/* contrib/pg_stat_statements/pg_stat_statements--1.3.sql */
+
+-- complain if script is sourced in psql, rather than via CREATE EXTENSION
+\echo Use "CREATE EXTENSION pg_stat_statements VERSION '1.3'" to load this file. \quit
+
+-- Register functions.
+CREATE FUNCTION pg_stat_statements_reset()
+RETURNS void
+AS 'MODULE_PATHNAME'
+LANGUAGE C;
+
+CREATE FUNCTION pg_stat_statements(IN showtext boolean,
+    OUT userid oid,
+    OUT dbid oid,
+    OUT queryid bigint,
+    OUT query text,
+    OUT calls int8,
+    OUT total_time float8,
+    OUT rows int8,
+    OUT shared_blks_hit int8,
+    OUT shared_blks_read int8,
+    OUT shared_blks_dirtied int8,
+    OUT shared_blks_written int8,
+    OUT local_blks_hit int8,
+    OUT local_blks_read int8,
+    OUT local_blks_dirtied int8,
+    OUT local_blks_written int8,
+    OUT temp_blks_read int8,
+    OUT temp_blks_written int8,
+    OUT blk_read_time float8,
+    OUT blk_write_time float8
+   , OUT aio_read_noneed int8
+   , OUT aio_read_discrd int8
+   , OUT aio_read_forgot int8
+   , OUT aio_read_noblok int8
+   , OUT aio_read_failed int8
+   , OUT aio_read_wasted int8
+   , OUT aio_read_waited int8
+   , OUT aio_read_ontime int8
+)
+RETURNS SETOF record
+AS 'MODULE_PATHNAME', 'pg_stat_statements_1_3'
+LANGUAGE C STRICT VOLATILE;
+
+-- Register a view on the function for ease of use.
+CREATE VIEW pg_stat_statements AS
+  SELECT * FROM pg_stat_statements(true);
+
+GRANT SELECT ON pg_stat_statements TO PUBLIC;
+
+-- Don't want this to be available to non-superusers.
+REVOKE ALL ON FUNCTION pg_stat_statements_reset() FROM PUBLIC;
--- contrib/pg_stat_statements/Makefile.orig	2014-08-18 14:10:36.757016243 -0400
+++ contrib/pg_stat_statements/Makefile	2014-08-19 16:56:13.007194736 -0400
@@ -4,7 +4,8 @@ MODULE_big = pg_stat_statements
 OBJS = pg_stat_statements.o $(WIN32RES)
 
 EXTENSION = pg_stat_statements
-DATA = pg_stat_statements--1.2.sql pg_stat_statements--1.1--1.2.sql \
+DATA = pg_stat_statements--1.3.sql pg_stat_statements--1.2--1.3.sql \
+	pg_stat_statements--1.2.sql pg_stat_statements--1.1--1.2.sql \
 	pg_stat_statements--1.0--1.1.sql pg_stat_statements--unpackaged--1.0.sql
 PGFILEDESC = "pg_stat_statements - execution statistics of SQL statements"
 
--- contrib/pg_stat_statements/pg_stat_statements.c.orig	2014-08-18 14:10:36.757016243 -0400
+++ contrib/pg_stat_statements/pg_stat_statements.c	2014-08-19 16:56:13.051194894 -0400
@@ -116,6 +116,7 @@ typedef enum pgssVersion
 	PGSS_V1_0 = 0,
 	PGSS_V1_1,
 	PGSS_V1_2
+	,PGSS_V1_3
 } pgssVersion;
 
 /*
@@ -147,6 +148,16 @@ typedef struct Counters
 	int64		local_blks_written;		/* # of local disk blocks written */
 	int64		temp_blks_read; /* # of temp blocks read */
 	int64		temp_blks_written;		/* # of temp blocks written */
+
+	int64		aio_read_noneed;		/* # of prefetches for which no need for prefetch as block already in buffer pool  */
+	int64		aio_read_discrd;		/* # of prefetches for which buffer not subsequently read and therefore discarded  */
+	int64		aio_read_forgot;		/* # of prefetches for which buffer not subsequently read and then forgotten about */
+	int64		aio_read_noblok;		/* # of prefetches for which no available BufferAiocb  control block               */
+	int64		aio_read_failed;		/* # of aio reads for which aio itself failed or the read failed with an errno     */
+	int64		aio_read_wasted;		/* # of aio reads for which in-progress aio cancelled and disk block not used      */
+	int64		aio_read_waited;		/* # of aio reads for which disk block used but had to wait for it                 */
+	int64		aio_read_ontime;		/* # of aio reads for which disk block used and ready on time when requested       */
+
 	double		blk_read_time;	/* time spent reading, in msec */
 	double		blk_write_time; /* time spent writing, in msec */
 	double		usage;			/* usage factor */
@@ -274,6 +285,7 @@ void		_PG_fini(void);
 
 PG_FUNCTION_INFO_V1(pg_stat_statements_reset);
 PG_FUNCTION_INFO_V1(pg_stat_statements_1_2);
+PG_FUNCTION_INFO_V1(pg_stat_statements_1_3);
 PG_FUNCTION_INFO_V1(pg_stat_statements);
 
 static void pgss_shmem_startup(void);
@@ -1025,7 +1037,25 @@ pgss_ProcessUtility(Node *parsetree, con
 		bufusage.temp_blks_read =
 			pgBufferUsage.temp_blks_read - bufusage_start.temp_blks_read;
 		bufusage.temp_blks_written =
-			pgBufferUsage.temp_blks_written - bufusage_start.temp_blks_written;
+			pgBufferUsage.temp_blks_written - bufusage.temp_blks_written;
+
+		bufusage.aio_read_noneed =
+			pgBufferUsage.aio_read_noneed - bufusage.aio_read_noneed;
+		bufusage.aio_read_discrd =
+			pgBufferUsage.aio_read_discrd - bufusage.aio_read_discrd;
+		bufusage.aio_read_forgot =
+			pgBufferUsage.aio_read_forgot - bufusage.aio_read_forgot;
+		bufusage.aio_read_noblok =
+			pgBufferUsage.aio_read_noblok - bufusage.aio_read_noblok;
+		bufusage.aio_read_failed =
+			pgBufferUsage.aio_read_failed - bufusage.aio_read_failed;
+		bufusage.aio_read_wasted =
+			pgBufferUsage.aio_read_wasted - bufusage.aio_read_wasted;
+		bufusage.aio_read_waited =
+			pgBufferUsage.aio_read_waited - bufusage.aio_read_waited;
+		bufusage.aio_read_ontime =
+			pgBufferUsage.aio_read_ontime - bufusage.aio_read_ontime;
+
 		bufusage.blk_read_time = pgBufferUsage.blk_read_time;
 		INSTR_TIME_SUBTRACT(bufusage.blk_read_time, bufusage_start.blk_read_time);
 		bufusage.blk_write_time = pgBufferUsage.blk_write_time;
@@ -1040,6 +1070,7 @@ pgss_ProcessUtility(Node *parsetree, con
 				   rows,
 				   &bufusage,
 				   NULL);
+
 	}
 	else
 	{
@@ -1223,6 +1254,16 @@ pgss_store(const char *query, uint32 que
 		e->counters.local_blks_written += bufusage->local_blks_written;
 		e->counters.temp_blks_read += bufusage->temp_blks_read;
 		e->counters.temp_blks_written += bufusage->temp_blks_written;
+
+		e->counters.aio_read_noneed     += bufusage->aio_read_noneed;
+		e->counters.aio_read_discrd     += bufusage->aio_read_discrd;
+		e->counters.aio_read_forgot     += bufusage->aio_read_forgot;
+		e->counters.aio_read_noblok     += bufusage->aio_read_noblok;
+		e->counters.aio_read_failed     += bufusage->aio_read_failed;
+		e->counters.aio_read_wasted     += bufusage->aio_read_wasted;
+		e->counters.aio_read_waited     += bufusage->aio_read_waited;
+		e->counters.aio_read_ontime     += bufusage->aio_read_ontime;
+
 		e->counters.blk_read_time += INSTR_TIME_GET_MILLISEC(bufusage->blk_read_time);
 		e->counters.blk_write_time += INSTR_TIME_GET_MILLISEC(bufusage->blk_write_time);
 		e->counters.usage += USAGE_EXEC(total_time);
@@ -1256,7 +1297,8 @@ pg_stat_statements_reset(PG_FUNCTION_ARG
 #define PG_STAT_STATEMENTS_COLS_V1_0	14
 #define PG_STAT_STATEMENTS_COLS_V1_1	18
 #define PG_STAT_STATEMENTS_COLS_V1_2	19
-#define PG_STAT_STATEMENTS_COLS			19		/* maximum of above */
+#define PG_STAT_STATEMENTS_COLS_V1_3	27
+#define PG_STAT_STATEMENTS_COLS			27		/* maximum of above */
 
 /*
  * Retrieve statement statistics.
@@ -1269,6 +1311,16 @@ pg_stat_statements_reset(PG_FUNCTION_ARG
  * function.  Unfortunately we weren't bright enough to do that for 1.1.
  */
 Datum
+pg_stat_statements_1_3(PG_FUNCTION_ARGS)
+{
+	bool		showtext = PG_GETARG_BOOL(0);
+
+	pg_stat_statements_internal(fcinfo, PGSS_V1_3, showtext);
+
+	return (Datum) 0;
+}
+
+Datum
 pg_stat_statements_1_2(PG_FUNCTION_ARGS)
 {
 	bool		showtext = PG_GETARG_BOOL(0);
@@ -1357,6 +1409,10 @@ pg_stat_statements_internal(FunctionCall
 			if (api_version != PGSS_V1_2)
 				elog(ERROR, "incorrect number of output arguments");
 			break;
+		case PG_STAT_STATEMENTS_COLS_V1_3:
+			if (api_version != PGSS_V1_3)
+				elog(ERROR, "incorrect number of output arguments");
+			break;
 		default:
 			elog(ERROR, "incorrect number of output arguments");
 	}
@@ -1533,11 +1589,24 @@ pg_stat_statements_internal(FunctionCall
 		{
 			values[i++] = Float8GetDatumFast(tmp.blk_read_time);
 			values[i++] = Float8GetDatumFast(tmp.blk_write_time);
+
+			if (api_version >= PGSS_V1_3)
+			{
+				values[i++] = Int64GetDatumFast(tmp.aio_read_noneed);
+				values[i++] = Int64GetDatumFast(tmp.aio_read_discrd);
+				values[i++] = Int64GetDatumFast(tmp.aio_read_forgot);
+				values[i++] = Int64GetDatumFast(tmp.aio_read_noblok);
+				values[i++] = Int64GetDatumFast(tmp.aio_read_failed);
+				values[i++] = Int64GetDatumFast(tmp.aio_read_wasted);
+				values[i++] = Int64GetDatumFast(tmp.aio_read_waited);
+				values[i++] = Int64GetDatumFast(tmp.aio_read_ontime);
+			}
 		}
 
 		Assert(i == (api_version == PGSS_V1_0 ? PG_STAT_STATEMENTS_COLS_V1_0 :
 					 api_version == PGSS_V1_1 ? PG_STAT_STATEMENTS_COLS_V1_1 :
 					 api_version == PGSS_V1_2 ? PG_STAT_STATEMENTS_COLS_V1_2 :
+					 api_version == PGSS_V1_3 ? PG_STAT_STATEMENTS_COLS_V1_3 :
 					 -1 /* fail if you forget to update this assert */ ));
 
 		tuplestore_putvalues(tupstore, tupdesc, values, nulls);
--- contrib/pg_stat_statements/pg_stat_statements--1.2--1.3.sql.orig	2014-08-19 10:17:32.814616339 -0400
+++ contrib/pg_stat_statements/pg_stat_statements--1.2--1.3.sql	2014-08-19 16:56:13.079194994 -0400
@@ -0,0 +1,51 @@
+/* contrib/pg_stat_statements/pg_stat_statements--1.2--1.3.sql */
+
+-- complain if script is sourced in psql, rather than via ALTER EXTENSION
+\echo Use "ALTER EXTENSION pg_stat_statements UPDATE TO '1.3'" to load this file. \quit
+
+/* First we have to remove them from the extension */
+ALTER EXTENSION pg_stat_statements DROP VIEW pg_stat_statements;
+ALTER EXTENSION pg_stat_statements DROP FUNCTION pg_stat_statements();
+
+/* Then we can drop them */
+DROP VIEW pg_stat_statements;
+DROP FUNCTION pg_stat_statements();
+
+/* Now redefine */
+CREATE FUNCTION pg_stat_statements(IN showtext boolean,
+    OUT userid oid,
+    OUT dbid oid,
+    OUT queryid bigint,
+    OUT query text,
+    OUT calls int8,
+    OUT total_time float8,
+    OUT rows int8,
+    OUT shared_blks_hit int8,
+    OUT shared_blks_read int8,
+    OUT shared_blks_dirtied int8,
+    OUT shared_blks_written int8,
+    OUT local_blks_hit int8,
+    OUT local_blks_read int8,
+    OUT local_blks_dirtied int8,
+    OUT local_blks_written int8,
+    OUT temp_blks_read int8,
+    OUT temp_blks_written int8,
+    OUT blk_read_time float8,
+    OUT blk_write_time float8
+   , OUT aio_read_noneed int8
+   , OUT aio_read_discrd int8
+   , OUT aio_read_forgot int8
+   , OUT aio_read_noblok int8
+   , OUT aio_read_failed int8
+   , OUT aio_read_wasted int8
+   , OUT aio_read_waited int8
+   , OUT aio_read_ontime int8
+)
+RETURNS SETOF record
+AS 'MODULE_PATHNAME', 'pg_stat_statements_1_3'
+LANGUAGE C STRICT VOLATILE;
+
+CREATE VIEW pg_stat_statements AS
+  SELECT * FROM pg_stat_statements(true);
+
+GRANT SELECT ON pg_stat_statements TO PUBLIC;
